#include <assert.h>
#include "pass1.h"
#include "pass2.h"

/*
 * Called before some sort of data is written out (or the
 * function epilog).  The target is supposed to generate
 * the needed assembly directives for the data.  The symbol
 * table pointer describes the symbol to be written out, or 
 * NULL if any state kept in the assembly output should be
 * forgotten (like after asm() directive). All targets
 * must implement this.
 */
/* cc/ccom/init.c:600 */
void defloc(struct symtab *sp)
{
}

/*
 * When the end of a function is reached a target may
 * want to write out some extra code before the epilog,
 * for example i386 generates struct return code here.
 */
/* cc/ccom/pftn.c:448 */
void efcode()
{
}

/*
 * Called after the header of a function declaration is read
 * after the parameters are declared.  A target may move
 * arguments to temporaries here to let the optimizer deal
 * with them.  Look at i386/code.c for an example of how
 * to do with arguments on stack, or pdp10/code.c for an 
 * example of how to deal with arguments in registers.
 *
 * 'sp' is an array of indices in symtab for the arguments
 * 'cnt' is the number of arguments
 */
/* cc/ccom/pftn.c:498 */
void bfcode(struct symtab **sp, int cnt)
{
}
/*
 * The opposite of ejobcode(), called before anything else
 * takes place.  Can be used to print out initial assembly 
 * directives, see m16c for an example.
 */
/* cc/ccom/trees.c:488 */
NODE * funcode(NODE *p)
{
  return p;
}

/*
 * Return the alignment of field of type t.  This function
 * is deprecated.
 */
/* cc/ccom/pftn.c:941 */
int fldal(unsigned int t)
{
  uerror("illegal field type");
  return(ALINT);
}

/*
 * Let the target decide whether or not to change type on 		
 * a bitfield declared.  Usually does nothing.
 */
/* cc/ccom/pftn.c:1330 */
void fldty(struct symtab *p)
{
}









/*
 * This function is called when all variables are declared
 * in a block before code is generated.  It's use is now
 * deprecated and will be removed in the future.
 */
/* cc/ccom/cgram.c:2794 */
void bccode()
{
}

/*
 * The last function, called when the parser is finished
 * just before exit.  Flag is set if an error occurred during
 * compilation.  Unused on most targets, m16c/code.c uses
 * it to write out external definitions for all undeclared
 * symbols.
 */
/* cc/ccom/main.c:310 */
void ejobcode(int flag )
{
}

/*
 * Beginning-of-job: called before compilation starts
 *
 * Initialise data structures specific for the local machine.
 */
/* cc/ccom/main.c:295 */
void bjobcode()
{
}



/*
 * Let the target generate optimized assembly for switch
 * statements, if desired.  Return 1 if handled and 0 if not.
 * Num is the TEMP node number containing the value to 
 * switch on, type is the type of num, p is an array of
 * pointers to swents structs each describing a case number
 * and n is the size of the swents switch.  See ccom/cgram.y
 * for the trivial default implementation.
 */
/* cc/ccom/cgram.c1:3911 */
int mygenswitch(int num, TWORD type, struct swents **p, int n)
{
  return 0;
}

