#include <assert.h>
#include <string.h>
#include "pass2.h"

/*
 * Check if it is legal to make an OREG or NAME entry which
 * has an offset of off, (from a register of r), if the
 * resulting thing had type t.  cp is an eventual string.
 */
/* mip/reader.c:1024 */
int notoff(TWORD t, int r, CONSZ off, char *cp)
{
  if(cp && cp[0]) return 1;
  return !(off <=  32767 && off >= -32768);
}
/*
 * This function is called when an UMUL is found to see if 
 * some smart transformation can be done, for example the
 * i386 can use multiple indexing like 4(%eax,%ebx,4).
 * It will only setup for transformation, not perform it.
 */
/* mip/match.c:447 */
void offstar(NODE *p, int shape)
{
}

/*
 * Do the actual node transformation of the construct 
 * found in offstar().  All leaves should be correct 
 * set here.
 */
/* mip/reader.c:1057 */
void myormake(NODE *q)
{
}

/*
 * See if a shape in the table matches UMUL so that it
 * is legal to later on call offstar().
 */
/* mip/match.c:180 */
int shumul(NODE *p)
{
  /* Turns currently anything into OREG */
  return SOREG;
}

/*
 * Called when a REWRITE rule for a binary node is found in
 * the table to see if something can be done about it.
*/
/* mip/match.c:600 */
int setbin(NODE *p)
{
  return 0;
}

/*
 * Rewrite assignment operations.
 * Called as a result of a failed table lookup.
 *
 * Return nonzero to retry table search on new tree, or zero to fail.
 */
/* mip/match.c:788 */
int setasg(NODE *p, int cookie)
{
  return 0;
}
/*
 * The same as setbin() but for assignment/unary nodes.
 */
/* mip/match.c:865 */
int setuni(NODE *p, int cookie)
{
  return 0;
}

/*
 * When a function has special needs (like input in a
 * specific register) this function is called while
 * traversing the table and emitting instructions.
*/
/* mip/reader.c:1194*/
struct rspecial *nspecial(struct optab *q)
{
  comperr("nspecial entry %d", q - table);
  return 0;
}

/*
 * If the target has different evaluation order needs
 * than the Sethi-Ullman calculations it may be set
 * here.  Called from sucomp().
 */
/* mip/regs.c:272 */
int setorder(NODE *p)
{
  return 0;
}

/*
 * Set registers live at a function call (for the register
 * allocator liveness analysis).  May be used when
 * arguments are in registers.  Returns a -1 - terminated
 * list with registers to set live.
 */
/* mip/regs.c:1032 */
int *livecall(NODE *p)
{
  static int r[] = {-1};
  return &r[0];
}

/*
 * Signal whether the instruction is acceptable for this target.
 * Targets may use the unused bits in the visit field and
 * then check them here when generating code.
 */
/* mip/match.c:563 */
int acceptable(struct optab *op)
{
  return 1;
}
